theory Constructions
imports Main
begin

typedecl point
typedecl line
typedecl circle
typedecl int

consts eq_point :: "point \<Rightarrow> point \<Rightarrow> bool"
consts not_eq_point :: "point \<Rightarrow> point \<Rightarrow> bool"
consts eq_line :: "line \<Rightarrow> line \<Rightarrow> bool"
consts not_eq_line :: "line \<Rightarrow> line \<Rightarrow> bool"
consts eq_circle :: "circle \<Rightarrow> circle \<Rightarrow> bool"
consts not_eq_circle :: "circle \<Rightarrow> circle \<Rightarrow> bool"
consts eq_int :: "int \<Rightarrow> int \<Rightarrow> bool"
consts not_eq_int :: "int \<Rightarrow> int \<Rightarrow> bool"

consts inc :: "point \<Rightarrow> line \<Rightarrow> bool"
consts not_inc :: "point \<Rightarrow> line \<Rightarrow> bool"
consts sratio_1_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_sratio_1_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_1_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts sratio_2_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_2_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts not_sratio_2_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratio_3_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_3_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts not_sratio_3_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratio_2_3 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_sratio_2_3 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts collinear :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_collinear :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts centroid :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts midpoint :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts parallel :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_parallel :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts bet :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_bet :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"

axiomatization where

ax_W01_F_3_2: "sratio_3_2 A B C D \<Longrightarrow>  B = sratioF_3_2 A C D"
and
ax_W01_F_2_1: "sratio_2_1 A B C D \<Longrightarrow>  B = sratioF_2_1 A C D"
and
ax_W01_F_1_2: "sratio_1_2 A B C D \<Longrightarrow>  B = sratioF_1_2 A C D"
and
ax_GL03a: "sratio_2_3 A B C D \<Longrightarrow> sratio_3_2 C D A B"
and
ax_GL03b: "sratio_1_2 A B C D \<Longrightarrow> sratio_2_1 C D A B"
and
ax_GL04: "sratio_1_2 A B A C \<Longrightarrow> sratio_1_2 C B C A"
and
ax_L56: "centroid G A B C  \<and> midpoint M_b A C \<Longrightarrow> sratio_2_3 B G B M_b"
and
ax_D4a: "inc A MA \<and> inc A1 MA \<and> inc B MB \<and> inc B1 MB \<and> sratio_1_2 B A1 B C \<and> sratio_1_2 C B1 C A 
        \<and> centroid G A B C \<Longrightarrow> (inc G MA \<and> inc G MB)"
and
ax_D4b: "inc A MA \<and> inc A1 MA \<and> inc B MB \<and> inc B1 MB \<and> sratio_1_2 B A1 B C \<and> sratio_1_2 C B1 C A 
        \<and> inc G MA \<and> inc G MB \<Longrightarrow> centroid G A B C"
and
ax_D22_1: "sratio_1_2 C M_b C A \<Longrightarrow> midpoint M_b A C"
and
ax_D22_2: " midpoint M_b A C \<Longrightarrow> sratio_1_2 C M_b C A "
and
ax_eq_point_false: "eq_point PO1 PO2 \<and> not_eq_point PO1 PO2 \<Longrightarrow> False"
and
ax_eq_point_false1: "(eq_point PO1 PO2 \<Longrightarrow> False) \<Longrightarrow> not_eq_point PO1 PO2"
and
ax_collinear_false: "collinear PO1 PO2 PO3 \<and> not_collinear PO1 PO2 PO3 \<Longrightarrow> False"
and
ax_collinear_false1: "(collinear PO1 PO2 PO3 \<Longrightarrow> False) \<Longrightarrow> not_collinear PO1 PO2 PO3"
and
ax_parallel_false1: "(parallel PO1 PO2 PO3 PO4 \<Longrightarrow> False) \<Longrightarrow> not_parallel PO1 PO2 PO3 PO4"
and
ax_ogp_proof: " (* no NDG conditions *) 
	       C = sratioF_2_1 A A M_b \<and> B = sratioF_2_1 A A M_c (* steps of construction *)
	        (* no auxiliary points needed for definitions of the barycenter *)
               \<Longrightarrow> midpoint M_b A C \<and> midpoint M_c A B"
and
ax_W01_3_2: " \<exists> (B::point). sratio_3_2 A B C D"
and
ax_W01_2_1: " \<exists> (B::point). sratio_2_1 A B C D" 
and
ax_W01_1_2: " \<exists> (B::point). sratio_1_2 A B C D" 
and
ax_collinear_eq4: "eq_point D A \<and> collinear A B C \<Longrightarrow> collinear D B C"
and
ax_collinear_sratio2_1_1: "collinear A B C  \<and> C = sratioF_2_1 A A D \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio2_1_2: "collinear A B D  \<and> C = sratioF_2_1 A A D \<Longrightarrow> collinear A B C"
and
ax_collinear_sratio2_1_3: "collinear A B D  \<and> C = sratioF_2_1 D D B \<Longrightarrow> collinear A C D"
and
ax_collinear_sratio2_1_4: "collinear A B D  \<and> B = sratioF_2_1 D D C \<Longrightarrow> collinear A C D"
and
ax_collinear_sratio2_1_5: "collinear A B D  \<and> C = sratioF_2_1 A A B \<Longrightarrow> collinear A D C"
and
ax_collinear_sratio2_1_6: "collinear A B C  \<and> C = sratioF_2_1 A A D \<Longrightarrow> collinear A D B"
and
ax_collinear_sratio3_2_1: "collinear A B C  \<and> C = sratioF_3_2 B B D \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio3_2_2: "collinear A B D  \<and> C = sratioF_3_2 B B D \<Longrightarrow> collinear A B C"
and
ax_sratio1_2_collinear: "A = sratioF_1_2 B B C \<Longrightarrow> collinear A B C"
and
ax_sratio3_2_collinear: "A = sratioF_3_2 B B C \<Longrightarrow> collinear A B C"
and
ax_sratio2_1_collinear: "A = sratioF_2_1 B B C \<Longrightarrow> collinear A B C"
and
ax_parallel: "parallel A B C D \<and> inc A P \<and> inc B P \<and> inc C Q \<and> inc D Q \<and> ( \<exists> (E::point). inc E P \<and> inc E Q) \<Longrightarrow> eq_lines P Q"
and
ax_eq_collin: "inc A P \<and> inc B P \<and> inc C Q \<and> inc D Q \<and> eq_lines P Q \<Longrightarrow> collinear A C B"
and
ax_bet_collin: "bet A B C  \<Longrightarrow> collinear A B C"
and
ax_D_line: " \<exists> (P::line). inc A P \<and> inc B P" 
and
ax_sratio1_2_bet: "A = sratioF_1_2 B B C \<Longrightarrow> bet B A C"
and
ax_pasch: "bet B M_a' C \<and> bet C M_b' A \<and> inc A P \<and> inc M_a' P \<and> inc B Q \<and> inc M_b' Q \<Longrightarrow> ( \<exists> (X::point). inc X P \<and> inc X Q)"
and
ax_col_col: "collinear A B C \<and> collinear B C D \<Longrightarrow> collinear A B D"

(************************)
(* ANALYSIS *)
(************************)

(* first step of the analysis *)

lemma  Thm_analysis_1:
assumes "not_collinear A B C"
and "midpoint M_b A C"
and "midpoint M_c A B"
shows "sratio_2_1 A C A M_b"

proof -

from  `midpoint M_b A C`
have "sratio_1_2 C M_b C A"
using ax_D22_2 [of "M_b" "A" "C"]
by auto

moreover
from  `sratio_1_2 C M_b C A`
have "sratio_1_2 A M_b A C"
using ax_GL04 
by auto

moreover
from  `sratio_1_2 A M_b A C`
have "sratio_2_1 A C A M_b"
using ax_GL03b 
by auto

moreover
from this
show ?thesis
by auto
(* ovo cemo dobiti iz ArgoTriCSa i ArgoCLPa *)
qed

(************************)

(* second step of the analysis *)

lemma  Thm_analysis_2:
assumes "not_collinear A B C"
and "midpoint M_b A C"
and "midpoint M_c A B"
and "sratio_2_1 A C A M_b"
shows "sratio_2_1 A B A M_c"

proof -

from  `midpoint M_c A B`
have "sratio_1_2 B M_c B A"
using ax_D22_2 [of "M_c" "A" "B"]
by auto

moreover
from  `sratio_1_2 B M_c B A`
have "sratio_1_2 A M_c A B"
using ax_GL04 
by auto

moreover
from  `sratio_1_2 A M_c A B`
have "sratio_2_1 A B A M_c"
using ax_GL03b 
by auto

moreover
from this
show ?thesis
by auto
(* ovo cemo dobiti iz ArgoTriCSa i ArgoCLPa *)
qed

(************************)

(* joined steps of the analysis *)

lemma  Thm_analysis_3:
assumes "not_collinear A B C"
and "midpoint M_b A C"
and "midpoint M_c A B"
shows "(sratio_2_1 A C A M_b \<and> sratio_2_1 A B A M_c)"

proof -

from `not_collinear A B C`
and `midpoint M_b A C`
and `midpoint M_c A B`
have  "sratio_2_1 A C A M_b"
using Thm_analysis_1
by auto

moreover
from `not_collinear A B C`
and `midpoint M_b A C`
and `midpoint M_c A B`
and  `sratio_2_1 A C A M_b`
have "sratio_2_1 A B A M_c"
using Thm_analysis_2
by auto

moreover 
from `sratio_2_1 A C A M_b` and `sratio_2_1 A B A M_c`
show ?thesis
by auto
qed

(****************************************)
(* PROOF *)
(****************************************)

(* Guessing the formula over A,M_b,M_c which follows from 
   the fact "collinear A B C" and from the construction *)

lemma Thm_proof_final:
assumes  (* no NDG conditions *)
	"not_collinear A M_b M_c" and (* condition over points A, M_b, M_c that is disovered as needed *) 
        "C = sratioF_2_1 A A M_b" and "B = sratioF_2_1 A A M_c" (* steps of construction *) 
shows "(not_collinear A B C \<and> midpoint M_b A C \<and> midpoint M_c A B)"
proof -

from `not_collinear A M_b M_c` and 
     `C = sratioF_2_1 A A M_b` and `B = sratioF_2_1 A A M_c`
show ?thesis
by (metis ax_ogp_proof ax_collinear_false ax_collinear_false1 ax_collinear_sratio2_1_1 ax_collinear_sratio2_1_6)
qed

(**********************************************)
(* DISCUSSION *)
(**********************************************)

lemma Thm_discussion_second_direction:
assumes PP: " (\<exists> (B::point) (C::point). midpoint M_b A C \<and> midpoint M_c A B \<and> not_collinear A B C)"
shows "not_collinear A M_b M_c"
proof -

from PP
show ?thesis 
by (metis Thm_analysis_3 ax_W01_F_2_1 ax_collinear_sratio2_1_2 ax_collinear_sratio2_1_5 ax_collinear_false ax_collinear_false1)
qed

(****************************************)

lemma Thm_discussion_first_direction:
assumes "not_collinear A M_b M_c"
shows " (\<exists> (B::point) (C::point). midpoint M_b A C \<and> midpoint M_c A B \<and> not_collinear A B C)"
proof -

from `not_collinear A M_b M_c`
show ?thesis
by (metis ax_collinear_false ax_collinear_false1 Thm_proof_final)
qed

(****************************************)

lemma Thm_discussion_final:
shows "(( not_collinear A M_b M_c \<longrightarrow> (\<exists> (B::point) (C::point). midpoint M_b A C \<and> midpoint M_c A B \<and> not_collinear A B C)) \<and>
 ((\<exists> (B::point) (C::point). midpoint M_b A C \<and> midpoint M_c A B \<and> not_collinear A B C) \<longrightarrow> not_collinear A M_b M_c))"
proof -

show ?thesis
by (metis Thm_discussion_first_direction Thm_discussion_second_direction)
qed




