
theory Constructions
imports Main
begin

typedecl point
typedecl line
typedecl circle
typedecl int

consts eq_point :: "point \<Rightarrow> point \<Rightarrow> bool"
consts not_eq_point :: "point \<Rightarrow> point \<Rightarrow> bool"
consts eq_line :: "line \<Rightarrow> line \<Rightarrow> bool"
consts not_eq_line :: "line \<Rightarrow> line \<Rightarrow> bool"
consts eq_circle :: "circle \<Rightarrow> circle \<Rightarrow> bool"
consts not_eq_circle :: "circle \<Rightarrow> circle \<Rightarrow> bool"
consts eq_int :: "int \<Rightarrow> int \<Rightarrow> bool"
consts not_eq_int :: "int \<Rightarrow> int \<Rightarrow> bool"

consts inc :: "point \<Rightarrow> line \<Rightarrow> bool"
consts not_inc :: "point \<Rightarrow> line \<Rightarrow> bool"
consts sratio_1_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_sratio_1_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_1_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts sratio_2_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_2_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts not_sratio_2_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratio_3_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_3_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts not_sratio_3_2 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratio_2_3 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_sratio_2_3 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratio_3_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts sratioF_3_1 :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point"
consts collinear :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_collinear :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts centroid :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts midpoint :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts parallel :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_parallel :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts bet :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"
consts not_bet :: "point \<Rightarrow> point \<Rightarrow> point \<Rightarrow> bool"

axiomatization where

ax_W01_F_3_2: "sratio_3_2 A B C D \<Longrightarrow>  B = sratioF_3_2 A C D"
and
ax_W01_F_2_1: "sratio_2_1 A B C D \<Longrightarrow>  B = sratioF_2_1 A C D"
and
ax_W01_F_1_2: "sratio_1_2 A B C D \<Longrightarrow>  B = sratioF_1_2 A C D"
and
ax_W01_F_2_1_inv: "B = sratioF_2_1 A C D \<Longrightarrow>  sratio_2_1 A B C D"
and
ax_W01_F_3_1: "sratio_3_1 A B C D \<Longrightarrow>  B = sratioF_3_1 A C D"
and
ax_GL03a: "sratio_2_3 A B C D \<Longrightarrow> sratio_3_2 C D A B"
and
ax_GL03b: "sratio_1_2 A B C D \<Longrightarrow> sratio_2_1 C D A B"
and
ax_GL03c: "sratio_1_3 A B C D \<Longrightarrow> sratio_3_1 C D A B"
and
ax_GL03d: "sratio_2_1 A B C D \<Longrightarrow> sratio_1_2 C D A B"
and
ax_GL04a: "sratio_1_2 A B A C \<Longrightarrow> sratio_1_2 C B C A"
and
ax_GL04b: "sratio_2_3 A B A C \<Longrightarrow> sratio_1_3 C B C A"
and
ax_L55: "centroid G A B C  \<and> midpoint M_a B C \<Longrightarrow> sratio_2_3 A G A M_a"
and
ax_L56: "centroid G A B C  \<and> midpoint M_b A C \<Longrightarrow> sratio_2_3 B G B M_b"
and
ax_D4a: "inc A MA \<and> inc A1 MA \<and> inc B MB \<and> inc B1 MB \<and> sratio_1_2 B A1 B C \<and> sratio_1_2 C B1 C A 
        \<and> centroid G A B C \<Longrightarrow> (inc G MA \<and> inc G MB)"
and
ax_D4b: "inc A MA \<and> inc A1 MA \<and> inc B MB \<and> inc B1 MB \<and> sratio_1_2 B A1 B C \<and> sratio_1_2 C B1 C A 
        \<and> inc G MA \<and> inc G MB \<Longrightarrow> centroid G A B C"
and
ax_D22_1: "sratio_1_2 C M_b C A \<Longrightarrow> midpoint M_b A C"
and
ax_D22_2: " midpoint M_b A C \<Longrightarrow> sratio_1_2 C M_b C A "
and
ax_eq_point_false: "eq_point PO1 PO2 \<and> not_eq_point PO1 PO2 \<Longrightarrow> False"
and
ax_eq_point_false1: "(eq_point PO1 PO2 \<Longrightarrow> False) \<Longrightarrow> not_eq_point PO1 PO2"
and
ax_collinear_false: "collinear PO1 PO2 PO3 \<and> not_collinear PO1 PO2 PO3 \<Longrightarrow> False"
and
ax_collinear_false1: "(collinear PO1 PO2 PO3 \<Longrightarrow> False) \<Longrightarrow> not_collinear PO1 PO2 PO3"
and
ax_parallel_false1: "(parallel PO1 PO2 PO3 PO4 \<Longrightarrow> False) \<Longrightarrow> not_parallel PO1 PO2 PO3 PO4"
and
ax_ogp_proof: "not_parallel A M_a' B M_b' \<and>  not_parallel M_a M_b A M_a' \<and> 
	       A = sratioF_3_1 M_a M_a G \<and> B = sratioF_3_1 M_b M_b G \<and> C = sratioF_2_1 B B M_a \<and>
	       M_a' = sratioF_1_2 B B C \<and> M_b' = sratioF_1_2 C C A
               \<Longrightarrow> centroid G A B C \<and> midpoint M_a B C \<and> midpoint M_b A C"
and
ax_W01_3_2: " \<exists> (B::point). sratio_3_2 A B C D"
and
ax_W01_3_1: " \<exists> (B::point). sratio_3_1 A B C D"
and
ax_W01_2_1: " \<exists> (B::point). sratio_2_1 A B C D" 
and
ax_W01_1_2: " \<exists> (B::point). sratio_1_2 A B C D" 
and
ax_collinear_eq4: "eq_point D A \<and> collinear A B C \<Longrightarrow> collinear D B C"
and
ax_not_parallel_eq: "eq_point M_a M_a' \<Longrightarrow> not_parallel M_a M_b A M_a'"
and
ax_collinear_sratio2_1_1: "collinear A B C  \<and> C = sratioF_2_1 A A D \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio2_1_8: "collinear A B C  \<and> C = sratioF_2_1 A A D \<Longrightarrow> collinear A D B"
and
ax_collinear_sratio2_1_9: "collinear A B C  \<and> D = sratioF_2_1 B B C \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio2_1_10: "collinear A B C  \<and> C = sratioF_2_1 B B D \<Longrightarrow> collinear D B A"
and
ax_collinear_sratio2_1_2: "collinear A B D  \<and> C = sratioF_2_1 A A D \<Longrightarrow> collinear A B C"
and
ax_collinear_sratio3_2_1: "collinear A B C  \<and> C = sratioF_3_2 B B D \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio3_2_2: "collinear A B D  \<and> C = sratioF_3_2 B B D \<Longrightarrow> collinear A B C"
and
ax_collinear_sratio3_1_1: "collinear A B C  \<and> C = sratioF_3_1 B B D \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio3_1_3: "collinear A B C  \<and> D = sratioF_3_1 A A C \<Longrightarrow> collinear D B A"
and
ax_collinear_sratio3_1_5: "collinear A B C  \<and> C = sratioF_3_1 A A D \<Longrightarrow> collinear A B D"
and
ax_collinear_sratio3_1_6: "collinear A B C  \<and> B = sratioF_3_1 D D C \<Longrightarrow> collinear A D C"
and
ax_collinear_sratio3_1_4: "collinear A B C  \<and> D = sratioF_3_1 A A C \<Longrightarrow> collinear D B C"
and
ax_collinear_sratio3_1_2: "collinear A B C  \<and> D = sratioF_3_1 B B C \<Longrightarrow> collinear A D B"
and
ax_sratio1_2_collinear: "A = sratioF_1_2 B B C \<Longrightarrow> collinear A B C"
and
ax_sratio3_2_collinear: "A = sratioF_3_2 B B C \<Longrightarrow> collinear A B C"
and
ax_sratio2_1_collinear: "A = sratioF_2_1 B B C \<Longrightarrow> collinear A B C"
and
ax_parallel: "parallel A B C D \<and> inc A P \<and> inc B P \<and> inc C Q \<and> inc D Q \<and> ( \<exists> (E::point). inc E P \<and> inc E Q) \<Longrightarrow> eq_lines P Q"
and
ax_eq_collin: "inc A P \<and> inc B P \<and> inc C Q \<and> inc D Q \<and> eq_lines P Q \<Longrightarrow> collinear A C B"
and
ax_bet_collin: "bet A B C  \<Longrightarrow> collinear A B C"
and
ax_D_line: " \<exists> (P::line). inc A P \<and> inc B P" 
and
ax_sratio1_2_bet: "A = sratioF_1_2 B B C \<Longrightarrow> bet B A C"
and
ax_pasch: "bet B M_a' C \<and> bet C M_b' A \<and> inc A P \<and> inc M_a' P \<and> inc B Q \<and> inc M_b' Q \<Longrightarrow> ( \<exists> (X::point). inc X P \<and> inc X Q)"
and
ax_col_col: "collinear A B C \<and> collinear B C D \<Longrightarrow> collinear A B D"
and
ax_col_col_1: "collinear A B C \<and> collinear A C D \<Longrightarrow> collinear A B D"
and
ax_eq_points_1_2: "M_a = sratioF_1_2 B B C \<and> M_a' = sratioF_1_2 B B C \<Longrightarrow> eq_point M_a M_a'"


(************************)
(* ANALYSIS *)
(************************)

(*first step of the analysis*)

lemma  Thm_analysis_1:
assumes "not_collinear A B C"
and "centroid G A B C"
and "midpoint M_b A C"
and "midpoint M_a B C"
shows "sratio_3_1 M_a A M_a G"
proof -

from  `centroid G A B C` and `midpoint M_a B C`
have "sratio_2_3 A G A M_a"
using ax_L55 [of "G" "A" "B" "C" "M_a"]
by auto

moreover
from `sratio_2_3 A G A M_a`
have "sratio_1_3 M_a G M_a A"
using ax_GL04b
by auto

moreover
from `sratio_1_3 M_a G M_a A`
have "sratio_3_1 M_a A M_a G"
using ax_GL03c
by auto

from this
show ?thesis
by auto
qed

(************************) 

(*second step of analysis*)

lemma  Thm_analysis_2:
assumes "not_collinear A B C"
and "centroid G A B C"
and "midpoint M_b A C"
and "midpoint M_a B C"
and "sratio_3_1 M_a A M_a G"
shows "sratio_3_1 M_b B M_b G"
proof -

from  `centroid G A B C` and `midpoint M_b A C`
have "sratio_2_3 B G B M_b"
using ax_L56 [of "G" "A" "B" "C" "M_b"]
by auto

moreover
from `sratio_2_3 B G B M_b`
have "sratio_1_3 M_b G M_b B"
using ax_GL04b
by auto

moreover
from `sratio_1_3 M_b G M_b B`
have "sratio_3_1 M_b B M_b G"
using ax_GL03c
by auto

from this
show ?thesis
by auto
qed

(************************) 

(*third step of analysis*)

lemma  Thm_analysis_3:
assumes "not_collinear A B C"
and "centroid G A B C"
and "midpoint M_b A C"
and "midpoint M_a B C"
and "sratio_3_1 M_a A M_a G"
and "sratio_3_1 M_b B M_b G"
shows "sratio_2_1 B C B M_a"
proof -

from `midpoint M_a B C`
have  "sratio_1_2 C M_a C B"
using ax_D22_2
by auto

moreover
from `sratio_1_2 C M_a C B`
have  "sratio_1_2 B M_a B C"
using ax_GL04a
by auto

moreover 
from  `sratio_1_2 B M_a B C`
have "sratio_2_1 B C B M_a"
using ax_GL03b 
by auto
 
from this
show ?thesis
by auto
qed

(******************************) 

(*joined three steps of analysis*)

lemma  Thm_analysis_final:
assumes "not_collinear A B C"
and "centroid G A B C"
and "midpoint M_b A C"
and "midpoint M_a B C"
shows "(sratio_3_1 M_a A M_a G \<and> sratio_3_1 M_b B M_b G \<and> sratio_2_1 B C B M_a)"
proof -

from `not_collinear A B C`
and `centroid G A B C`
and `midpoint M_b A C`
and `midpoint M_a B C`
have  "sratio_3_1 M_a A M_a G"
using Thm_analysis_1
by auto

moreover
from `not_collinear A B C`
and `centroid G A B C`
and `midpoint M_b A C`
and `midpoint M_a B C`
and  `sratio_3_1 M_a A M_a G`
have "sratio_3_1 M_b B M_b G"
using Thm_analysis_2
by auto

moreover
from `not_collinear A B C`
and `centroid G A B C`
and `midpoint M_b A C`
and `midpoint M_a B C`
and `sratio_3_1 M_a A M_a G`
and `sratio_3_1 M_b B M_b G`
have "sratio_2_1 B C B M_a"
using Thm_analysis_3
by auto

moreover 
from `sratio_3_1 M_a A M_a G` and `sratio_3_1 M_b B M_b G` and `sratio_2_1 B C B M_a`
show ?thesis
by auto
qed

(****************************************)
(* PROOF *)
(****************************************)
 
(* Guessing the formula over M_a,M_b,G which follows from 
   the fact "collinear A B C" and from the construction *)

lemma Thm_proof_final:
assumes "not_parallel A M_a' B M_b'" and "not_parallel M_a M_b A M_a'" and  (* NDG conditions *)
	"not_collinear M_a M_b G" and (* condition over points A, M_b, G that is disovered as needed *) 
        "A = sratioF_3_1 M_a M_a G" and "B = sratioF_3_1 M_b M_b G" and "C = sratioF_2_1 B B M_a" and (* steps of construction *)
        "M_a' = sratioF_1_2 B B C" and "M_b' = sratioF_1_2 C C A" (* no auxiliary points needed for definitions of the barycenter *)
shows "(not_collinear A B C \<and> centroid G A B C \<and> midpoint M_a B C \<and> midpoint M_b A C)"
proof -

from `not_parallel A M_a' B M_b'` 
and `not_parallel M_a M_b A M_a'`
and `not_collinear M_a M_b G` 
and `A = sratioF_3_1 M_a M_a G` 
and `B = sratioF_3_1 M_b M_b G` 
and `C = sratioF_2_1 B B M_a`
and `M_a' = sratioF_1_2 B B C` 
and `M_b' = sratioF_1_2 C C A` 
show ?thesis

by (metis ax_ogp_proof ax_collinear_false ax_collinear_false1 ax_collinear_sratio2_1_10 ax_collinear_sratio3_1_5  ax_collinear_sratio3_1_6)
qed


(**********************************************)
(* DISCUSSION *)
(**********************************************)

(*One direction of the main theorem *)

lemma Thm_discussion_second_direction:
assumes PP: " (\<exists> (A::point) (B::point) (C::point). centroid G A B C \<and> midpoint M_a B C \<and> midpoint M_b A C \<and> not_collinear A B C)"
shows "not_collinear M_a M_b G"
proof -

from PP
show ?thesis 
by (metis ax_collinear_sratio3_1_2 ax_collinear_sratio3_1_3 ax_collinear_sratio2_1_9 ax_col_col_1 ax_collinear_false ax_collinear_false1 ax_W01_F_3_1 ax_W01_F_2_1 Thm_analysis_final)
qed

(****************************************) 

lemma Lemma_parallel_collinear:
assumes "parallel A M_a' B M_b'"
and "M_a' = sratioF_1_2 B B C"
and "M_b' = sratioF_1_2 C C A"
shows "collinear A B C "
proof -

(*
from `parallel A M_a' B M_b'`
and `M_a' = sratioF_1_2 B B C`
and `M_b' = sratioF_1_2 C C A`
show ?thesis
by (metis ax_sratio1_2_bet ax_D_line ax_pasch ax_parallel ax_eq_collin ax_bet_collin ax_col_col)
qed
*)

from `M_a' = sratioF_1_2 B B C`
have "bet B M_a' C"
using ax_sratio1_2_bet
by auto

moreover
from `M_b' = sratioF_1_2 C C A`
have "bet C M_b' A"
using ax_sratio1_2_bet
by auto

moreover
obtain P::line      
where "inc A P" and "inc M_a' P"
using ax_D_line
by auto

moreover
obtain Q::line      
where "inc B Q" and "inc M_b' Q"
using ax_D_line
by auto

moreover
from `bet B M_a' C` 
and `bet C M_b' A` 
and `inc A P` 
and `inc M_a' P`
and `inc B Q` 
and `inc M_b' Q`
have "\<exists> (X::point). inc X P \<and> inc X Q"
using ax_pasch [of "B" "M_a'" "C" "M_b'" "A" "P" "Q"]
by auto

moreover
from `parallel A M_a' B M_b'` 
and `inc A P` 
and `inc M_a' P`
and `inc B Q` 
and `inc M_b' Q` 
and `\<exists> (X::point). inc X P \<and> inc X Q`
have "eq_lines P Q"
using ax_parallel [of "A" "M_a'" "B" "M_b'" "P" "Q"]
by auto

moreover
from `inc A P` 
and `inc M_a' P`
and `inc B Q` 
and `inc M_b' Q`
and `eq_lines P Q`
have "collinear A B M_a'"
using ax_eq_collin [of "A" "P" "M_a'" "B" "Q" "M_b'"]
by auto 

moreover
from `bet  B M_a' C`
have "collinear B M_a' C"
using ax_bet_collin
by auto

moreover
from `collinear A B M_a'` 
and `collinear B M_a' C`
have "collinear A B C"
using ax_col_col [of "A" "B" "M_a'" "C"]
by auto

moreover
from this
show ?thesis
by auto
qed

(****************************************)

(* contraposition of the previous theorem *)

lemma Lemma_parallel_collinear_c:
assumes "not_collinear A B C"
and "M_a' = sratioF_1_2 B B C"
and "M_b' = sratioF_1_2 C C A"
shows "not_parallel A M_a' B M_b'"
proof -

from `not_collinear A B C`
and `M_a' = sratioF_1_2 B B C`
and `M_b' = sratioF_1_2 C C A`
show ?thesis
by (metis Lemma_parallel_collinear ax_collinear_false ax_parallel_false1)
qed

(****************************************)

(* the second NGD condition *)

lemma Lemma_parallel_collinear_2:
assumes "M_a' = sratioF_1_2 B B C"
and "C = sratioF_2_1 B B M_a"
shows "not_parallel M_a M_b A M_a'"
proof -

from `C = sratioF_2_1 B B M_a`
have "sratio_2_1 B C B M_a"
using ax_W01_F_2_1_inv
by auto

moreover 
from `sratio_2_1 B C B M_a`
have "sratio_1_2 B M_a B C"
using ax_GL03d
by auto

moreover
from `sratio_1_2 B M_a B C`
have "M_a =  sratioF_1_2 B B C"
using ax_W01_F_1_2
by auto

moreover
from `M_a = sratioF_1_2 B B C`
and `M_a' = sratioF_1_2 B B C`
have "eq_point M_a M_a'"
using ax_eq_points_1_2
by auto

moreover
from `eq_point M_a M_a'`
have "not_parallel M_a M_b A M_a'"
using ax_not_parallel_eq
by auto

from this
show ?thesis
by auto
qed


(****************************************)

lemma Thm_discussion_first_direction:
assumes "not_collinear M_a M_b G"
shows " (\<exists> (A::point) (B::point) (C::point). not_collinear A B C \<and> midpoint M_a B C \<and> midpoint M_b A C \<and> centroid G A B C)"
(*shows " (\<exists> (A::point) (B::point) (C::point) (M_a'::point) (M_b'::point). A = sratioF_3_1 M_a M_a G \<and> B = sratioF_3_1 M_b M_b G \<and> C = sratioF_2_1 B B M_a \<and> M_a' = sratioF_1_2 B B C \<and> M_b' = sratioF_1_2 C C A \<and> not_parallel A M_a' B M_b' \<and> not_parallel M_a M_b A M_a')"*)
proof -

from `not_collinear M_a M_b G`
show ?thesis
by (metis Thm_proof_final ax_W01_3_1 ax_W01_2_1 ax_W01_F_3_1 ax_W01_F_2_1 ax_W01_1_2 ax_W01_F_1_2 ax_collinear_false ax_collinear_false1 ax_collinear_sratio2_1_10 ax_collinear_sratio3_1_5  ax_collinear_sratio3_1_6 Lemma_parallel_collinear_c Lemma_parallel_collinear_2)
qed

(****************************************)

lemma Thm_discussion_final:
shows "(( not_collinear M_a M_b G \<longrightarrow> (\<exists> (A::point) (B::point) (C::point). centroid G A B C \<and> midpoint M_a B C \<and> midpoint M_b A C \<and> not_collinear A B C)) \<and>
 ((\<exists> (A::point) (B::point) (C::point). centroid G A B C \<and> midpoint M_a B C \<and> midpoint M_b A C \<and> not_collinear A B C) \<longrightarrow> not_collinear M_a M_b G))"
proof -

show ?thesis
by (metis Thm_discussion_first_direction Thm_discussion_second_direction)
qed




